SystemOrganization addCategory: #ConfigurationOfZ3950!

Object subclass: #ConfigurationOfZ3950
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfZ3950'!

!ConfigurationOfZ3950 commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfZ3950 class methodsFor: 'development support' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfZ3950 class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfZ3950 class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 2/6/2014 19:03'!
catalogChangeLog
		
	^ ''

! !

!ConfigurationOfZ3950 class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 2/6/2014 19:03'!
catalogContactInfo

	^ 'Configuration by hernan.morales@gmail.com
Binding developement by hernan.morales@gmail.com'
! !

!ConfigurationOfZ3950 class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 2/6/2014 19:16'!
catalogDescription

	^ 'Z39.50 is an international standard client–server, application layer communications protocol for searching and retrieving information from a database over a TCP/IP computer network. It is covered by ANSI/NISO standard Z39.50, and ISO standard 23950. The standard''s maintenance agency is the Library of Congress.

Z39.50 is widely used in library environments and is often incorporated into integrated library systems and personal bibliographic reference software. Interlibrary catalogue searches for interlibrary loan are often implemented with Z39.50 queries.

This is a ZOOM FFI Client for Z39.50 Protocol. A binding of the ZOOM Yaz client for Squeak and Pharo.'! !

!ConfigurationOfZ3950 class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 2/6/2014 19:28'!
catalogKeyClassesAndExample

	^ ' == XXXX== is the main public class of the package. It is the class to interact with as shown by the tests. 

Example of XXXXX

[[[
XXXXXX
]]]

The following is an example of XXXX
[[[ 
XXXX
]]]

'! !

!ConfigurationOfZ3950 class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 2/6/2014 19:05'!
catalogKeywords
	^ #(Z3950 protocol 23950 library bibiliographic interlibrary CQL SRU SRW)! !

!ConfigurationOfZ3950 class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfZ3950 class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfZ3950 class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfZ3950 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfZ3950 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfZ3950 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfZ3950 class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
project

	^self new project! !

!ConfigurationOfZ3950 class methodsFor: 'development support' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfZ3950 methodsFor: 'baselines' stamp: 'HernanMoralesDurand 7/6/2015 22:06'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/Z3950/main'.
		spec 
			project: 'FFI' with: [
				spec
					className: #ConfigurationOfFFI;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main' ];
			project: 'NeoCSV' with: [
				spec
					className: #ConfigurationOfNeoCSV;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ].
		spec 
			package: 'YAZ' with: [
				spec requires: #('FFI' ). ];
			package: 'Z3950' with: [
				spec requires: #('YAZ' ). ];
			package: 'Z3950Servers' with: [
				spec requires: #('Z3950' ). ];
			package: 'Z3950Tests' with: [
				spec requires: #('Z3950' ). ];
			package: 'YAZTests' with: [
				spec requires: #('YAZ' ). ].
		spec group: 'default' with: #('Z3950' 'Z3950Tests' 'Z3950Servers' ). ].
! !

!ConfigurationOfZ3950 methodsFor: 'baselines' stamp: 'HernanMoralesDurand 7/6/2015 22:06'!
baseline11: spec
	<version: '1.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/Z3950/main'.
		spec 
			project: 'FFI' with: [
				spec
					className: #ConfigurationOfFFI;
					versionString: #'stable';
					repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main' ];
			project: 'NeoCSV' with: [
				spec
					className: #ConfigurationOfNeoCSV;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ].
		spec 
			package: 'YAZ' with: [
				spec requires: #('FFI' ). ];
			package: 'Z3950' with: [
				spec requires: #('YAZ' ). ];
			package: 'Z3950Servers' with: [
				spec requires: #('Z3950' ). ];
			package: 'Z3950Tests' with: [
				spec requires: #('Z3950' ). ];
			package: 'YAZTests' with: [
				spec requires: #('YAZ' ). ].
		spec group: 'default' with: #('Z3950' 'Z3950Tests' 'Z3950Servers' ). ].
! !

!ConfigurationOfZ3950 methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfZ3950 methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 7/6/2015 22:06'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1-baseline'.
! !

!ConfigurationOfZ3950 methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/6/2014 19:27'!
platformLibraryUrl
	" Answer a download URL for the compiled version of library "

	Smalltalk os isWin32 
		ifTrue: [ ^ 'http://dl.dropboxusercontent.com/u/103833630/yazlibs.zip' ].
	Smalltalk os isUnix 
		ifTrue: [ ^ '' ].
	Smalltalk os isMacOSX
		ifTrue: [ ^ '' ].
	self error: 'Cannot find library for your OS platform'.! !

!ConfigurationOfZ3950 methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/6/2014 19:02'!
preLoad

	| url fileRef response |

	url := self platformLibraryUrl asZnUrl.
	fileRef := FileSystem disk workingDirectory / url pathSegments last.
	(response := ZnEasy get: url) isSuccess
		ifTrue: [ fileRef writeStreamDo: [ : stream | stream nextPutAll: response contents ] ]
		ifFalse: [ self error: 'Cannot download compiled library file' ].
	self uncompress: fileRef.! !

!ConfigurationOfZ3950 methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/6/2014 18:58'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfZ3950 methodsFor: 'baselines' stamp: 'HernanMoralesDurand 2/6/2014 19:01'!
specForFFIPharo3: spec

	spec
		project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main' ];
		yourself.
        ! !

!ConfigurationOfZ3950 methodsFor: 'baselines' stamp: 'HernanMoralesDurand 7/6/2015 21:50'!
specForFFIPharo4: spec

	spec
		project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main' ];
		yourself.
        ! !

!ConfigurationOfZ3950 methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 7/6/2015 21:50'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
	spec for: #'pharo3.x' version: '1.0'.
	spec for: #'pharo4.x' version: '1.0'.

! !

!ConfigurationOfZ3950 methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/6/2014 19:02'!
uncompress: fileRef
	" Private - Uncompress fileRef to the current working directory "

	| dst |
	
	dst := FileSystem workingDirectory / 'pharo-vm'.
	(fileRef fullName endsWith: '.zip')
		ifTrue: [ ZipArchive new 
					readFrom: fileRef fullName;
					extractAllTo: dst ].
	(fileRef fullName endsWith: '.gz')
		ifTrue: [ | unzipped |
			unzipped := GZipReadStream unzip: fileRef basename to: FileSystem workingDirectory.
			(FileSystem workingDirectory / unzipped) 
				renameTo: unzipped asFileReference basenameWithoutExtension ].! !

!ConfigurationOfZ3950 methodsFor: 'versions' stamp: 'HernanMoralesDurand 7/6/2015 22:08'!
version10: spec
    "The name for this version is solely defined by the following pragma:"
    <version: '1.0' imports: #('1.0-baseline') >
    "Baselines are used to define more complex setups for your project.
    If you want to use external projects and have fine-graind control of the dependencies between packages use the #imports: part.
    See the #baseline10: for more details."
    "Using #for:do: with the #common release specifier the following version declaration is valid for all platforms."
    spec for: #common do: [
        spec
            blessing: #release;       
            description: 'Version 1.0 the current stable release';
            author: 'Hernan Morales Durand';
            timestamp: '2015-06-07'.
        spec package: 'Z3950' with: 'Z3950-HernanMoralesDurand.32' ].

! !
